Meet our new project:Cladd — A React UI kit for building actual apps

Navigation Router

Framework7-Vue as Framework7 itself comes with powerful and flexible router. And to make it work we must specify Routes.

The only difference in Framework7-Vue is that in Vue.js we are already composing our application with Vue components, so we need to map our Pages (Vue components) to the routes. It can be done by passing Vue component in component property of the route. Here's a basic example:

<!-- app.vue -->
<template>
  <f7-app v-bind="f7params">
    <!-- Current View/Router, initial page will be loaded from home.vue component -->
    <f7-view main url="/"></f7-view>
  </f7-app>
</template>

<script>
  /* Import pages components */
  import HomePage from 'home.vue'
  import AboutPage from 'about.vue'
  import LoginPage from 'login.vue'

  /*
  Now we need to map components to routes.
  We need to pass them along with the F7 app parameters to <f7-app> component
  */

  export default {
    data() {
      return {
        // app params
        f7params: {
          name: 'My App',
          // specify routes for app
          routes: [
            {
              path: '/',
              component: HomePage,
            },
            {
              path: '/about/',
              component: AboutPage,
            },
            {
              path: '/login/',
              component: LoginPage,
            },
            // ...
          ],
          // ...
        }
      };
    },
  }
</script>
<!-- home.vue -->
<template>
  <f7-page name="home">
    <f7-navbar title="Home"></f7-navbar>
    <!-- Page content -->
    ...
    <f7-link href="/about/">About Page</f7-link>
    <f7-link href="/login/">Login Page</f7-link>
  </f7-page>
</template>
<script>
  export default {}
</script>


<!-- about.vue -->
<template>
  <f7-page name="about">
    <f7-navbar title="About"></f7-navbar>
    <!-- Page content -->
  </f7-page>
</template>
<script>
  export default {}
</script>

<!-- login.vue -->
<template>
  <f7-page name="login">
    <f7-navbar title="Login"></f7-navbar>
    <!-- Page content -->
  </f7-page>
</template>
<script>
  export default {}
</script>

Check the full Routes Documentation to know about all possible routes options, how to use Nested Routes, Routable Tabs and Routable Modals.

Pass Props To Components

It is possible to pass component props to Vue components loaded by router. There are few ways to do it.

First of all, all route params will be automatically passed as props to component, e.g.

// route with params
{
  path: '/blog/:postId/comments/:commentId/',
  component: BlogPost,
}

So if we navigate by /blog/45/comments/122/ URL, then the following data will be passed to props:

{
  postId: '45',
  commentId: '122',
}

Another option is to specify props in route's options:

{
  path: '/some-page/',
  component: SomeComponent,
  options: {
    props: {
      foo: 'bar',
      bar: true,
    },
  },
}

And finally, props can be passed dynamically to route component when we navigate with API:

f7router.navigate('/some-page/', {
  props: {
    foo: 'bar',
    bar: true,
  }
})

Async Lazy Components

With Webpack it is possible to load page components on demand, it is possible with F7's route asyncComponent, for example:

{
  path: '/about/',
  asyncComponent: () => import('./pages/about.vue'),
},

Or with async route if we need more control over it:

{
  path: '/about/',
  async({ resolve }) {
    // dynamic import component; returns promise
    const vueComponent = () => import('./pages/about.vue');
    // resolve promise
    vueComponent().then((vc) => {
      // resolve with component
      resolve({ component: vc.default })
    });
  } ,
},

Router API

To access router instance and use Router API you can use special f7router component prop of component:

<template>
  ...
  <f7-link @click="f7router.navigate('/about/')">About</f7-link>
  <f7-link @click="f7router.back()">Go Back</f7-link>
</template>
<script>
  export default {
    props: {
      f7router: Object,
    }
  }
</script>

Please note, that f7route and f7router component props are only available inside of custom page components that you load according to routes. In parent components (like in View, or where you init your Vue app instance) and in child components they are not accessible. So in this case use access to initialized View Instance, e.g. f7.views.main.router

Meet our new project:Cladd — A React UI kit for building actual apps

Navigation Router

Framework7-React as Framework7 itself comes with powerful and flexible router. And to make it work we must specify Routes.

The only difference in Framework7-React is that in React.js we are already composing our application with React components, so we need to map our Pages (React components) to the routes. It can be done by passing React component in component property of the route. Here's a basic example:

// App.jsx

// Import pages components
import HomePage from 'home.jsx';
import AboutPage from 'about.jsx';
import LoginPage from 'login.jsx';

/*
  Now we need to map components to routes.
  We need to pass them along with the F7 app parameters to <App> component
*/

const f7params = {
  name: 'My App',
  // specify routes for app
  routes: [
    {
      path: '/',
      component: HomePage,
    },
    {
      path: '/about/',
      component: AboutPage,
    },
    {
      path: '/login/',
      component: LoginPage,
    },
  ],
};

export default () => (
  <App { ...f7params }>
    {/* Current View/Router, initial page will be loaded from home.jsx component */}
    <View main url="/" />
  </App>
)
// home.jsx
export default () => (
  <Page name="home">
    <Navbar title="Home Page" />
    ...
    <Link href="/about/">About Page</Link>
    <Link href="/login/">Login Page</Link>
  </Page>
)
// about.jsx
export default () => (
  <Page name="about">
    <Navbar title="About" />
    {/* Page content */}
    ...
  </Page>
)
// login.jsx
export default () => (
  <Page name="login">
    <Navbar title="Login" />
    {/* Page content */}
    ...
  </Page>
)

Check the full Routes Documentation to know about all possible routes options, how to use Nested Routes, Routable Tabs and Routable Modals.

Pass Props To Components

It is possible to pass component props to React components loaded by router. There are few ways to do it.

First of all, all route params will be automatically passed as props to component, e.g.

// route with params
{
  path: '/blog/:postId/comments/:commentId/',
  component: BlogPost,
}

So if we navigate by /blog/45/comments/122/ URL, then the following data will be passed to props:

{
  postId: '45',
  commentId: '122',
}

Another option is to specify props in route's options:

{
  path: '/some-page/',
  component: SomeComponent,
  options: {
    props: {
      foo: 'bar',
      bar: true,
    },
  },
}

And finally, props can be passed dynamically to route component when we navigate with API:

f7router.navigate('/some-page/', {
  props: {
    foo: 'bar',
    bar: true,
  }
})

Async Lazy Components

With Webpack it is possible to load page components on demand, it is possible with F7's route asyncComponent, for example:

{
  path: '/about/',
  asyncComponent: () => import('./pages/about.jsx'),
},

Or with async route if we need more control over it:

{
  path: '/about/',
  async({ resolve }) {
    // dynamic import component; returns promise
    const reactComponent = () => import('./pages/about.jsx');
    // resolve promise
    reactComponent().then((rc) => {
      // resolve with component
      resolve({ component: rc.default })
    });
  } ,
},

Router API

To access router instance and use Router API you can use special f7router component prop of component:

export default ({ f7router }) => {
  return (
    <Page>
      <Link onClick={() => f7route.navigate('/about/')}>About</Link>
      <Link onClick={() => f7route.back()}>Back</Link>
    </Page>
  )
}

Please note, that f7route and f7router component props are only available inside of custom page components that you load according to routes. In parent components (like in View, or where you init your React app instance) and in child components they are not accessible. So in this case use access to initialized View Instance, e.g. f7.views.main.router

Meet our new project:Cladd — A React UI kit for building actual apps

Navigation Router

Framework7 Svelte as Framework7 itself comes with powerful and flexible router. To make it work we must specify Routes.

The only difference in Framework7 Svelte, is that in Svelte we are already composing our application with Svelte components, so we need to map our Pages (Svelte components) to the routes. This can be done by passing Svelte component in component property of the route. Here's a basic example:

<!-- App.svelte -->
<App { ...f7params }>
  <!-- Current View/Router, initial page will be loaded from home.svelte component -->
  <View main url="/" />
</App>
<script>
  // Import pages components
  import HomePage from 'home.svelte';
  import AboutPage from 'about.svelte';
  import LoginPage from 'login.svelte';

  /*
    Now we need to map components to routes.
    We need to pass them along with the F7 app parameters to <App> component
  */

  const f7params = {
    name: 'My App',
    // specify routes for app
    routes: [
      {
        path: '/',
        component: HomePage,
      },
      {
        path: '/about/',
        component: AboutPage,
      },
      {
        path: '/login/',
        component: LoginPage,
      },
    ],
  };
</script>
<!-- home.svelte -->
<Page name="home">
  <Navbar title="Home Page" />
  ...
  <Link href="/about/">About Page</Link>
  <Link href="/login/">Login Page</Link>
</Page>
<script>
  import { Page, Navbar, Link } from 'framework7-svelte';
</script>
<!-- about.svelte -->
<Page name="about">
  <Navbar title="About" />
  <!-- Page content -->
  ...
</Page>
<script>
  import { Page, Navbar } from 'framework7-svelte';
</script>
<!-- login.svelte -->
<Page name="login">
  <Navbar title="Login" />
  <!-- Page content -->
  ...
</Page>
<script>
  import { Page, Navbar } from 'framework7-svelte';
</script>

Check the full Routes Documentation to learn about all possible routes options, how to implement Nested Routes, Routable Tabs and Routable Modals.

Pass Props To Components

It is possible to pass component props to Svelte components loaded by router. There are few ways to do it.

First of all, all route params will be automatically passed as props to component, e.g.

// route with params
{
  path: '/blog/:postId/comments/:commentId/',
  component: BlogPost,
}

So if we navigate by /blog/45/comments/122/ URL, then the following data will be passed to props:

{
  postId: '45',
  commentId: '122',
}

Another option is to specify props in route's options:

{
  path: '/some-page/',
  component: SomeComponent,
  options: {
    props: {
      foo: 'bar',
      bar: true,
    },
  },
}

And finally, props can be passed dynamically to route component when we navigate with API:

f7router.navigate('/some-page/', {
  props: {
    foo: 'bar',
    bar: true,
  }
})

Async Lazy Components

With Webpack it is possible to load page components on demand, it is possible with F7's route asyncComponent, for example:

{
  path: '/about/',
  asyncComponent: () => import('./pages/about.svelte'),
},

Or with async route if we need more control over it:

{
  path: '/about/',
  async({ resolve }) {
    // dynamic import component, returns promise
    import('./pages/about.svelte').then((module) => {
      // resolve with component
      resolve({ component: module.default })
    });
  } ,
},

Router API

To access router instance and use Router API you can use special f7router component prop of component:

<Page>
  ...
  <Link onClick={() => f7router.navigate('/about/')}>About</Link>
  <Link onClick={() => f7router.back()}>Go Back</Link>
</Page>
<script>
  import { onMount } from 'svelte';
  import { Page, Link } from 'framework7-svelte';

  // Router component will receive f7router prop with current Router instance
  export let f7router;
  // Router component will receive f7route prop with current route data
  export let f7route;

  onMount(() => {
    // output current route data
    console.log(f7route); // -> { url: '/foo/', query: { id: 3 }, ... }
  });
</script>